//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#include <vcl\IniFiles.hpp>
#include <stdio.h>
#include <string.h>
#pragma hdrstop

#include "mainform.h"
//---------------------------------------------------------------------------
#pragma link "Grids"
#pragma link "Port_32"
#pragma resource "*.dfm"

static Word  PortWSel,PortRSel,NomWSel,NomRSel;
UCHAR ValWSel;

TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
void ShowButtons()
{
   Form1->C_Hard->Checked = Form1->HwCtrl->HardAccess;
   if (Form1->HwCtrl->ActiveHW) Form1->B_Open->Caption ="Close Driver";
                           else Form1->B_Open->Caption ="Open Driver";
   Form1->B_Write->Enabled = Form1->HwCtrl->ActiveHW;
   Form1->B_Read->Enabled = Form1->HwCtrl->ActiveHW;
   Form1->B_Exchange->Enabled = Form1->HwCtrl->ActiveHW;
   Form1->B_WriteAll->Enabled = Form1->HwCtrl->ActiveHW;
   Form1->B_ReadAll->Enabled = Form1->HwCtrl->ActiveHW;

};
//---------------------------------------------------------------------------
void __fastcall TForm1::C_HardClick(TObject *Sender)
{
 HwCtrl->HardAccess = C_Hard->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::B_OpenClick(TObject *Sender)
{
  if (HwCtrl->ActiveHW) HwCtrl->CloseDriver(); 
  else {
         HwCtrl->OpenDriver();
         if(!HwCtrl->ActiveHW) {
           MessageBeep(0);
           Application->MessageBox("Driver < VICHWxx > not found",
                      " Warning! ",IDOK);
         };
       };
  ShowButtons();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::BitBtn3Click(TObject *Sender)
{
 int i;
 TIniFile* MyIniFile = new TIniFile("HW_test");
 for (i=1; i<=16; i++) {
    MyIniFile->WriteString("PortW","Port"+IntToStr(i),GWrite->Cells[1][i]);
    MyIniFile->WriteString("Values","Val"+IntToStr(i),GWrite->Cells[2][i]);
    MyIniFile->WriteString("PortR","Port"+IntToStr(i),GRead->Cells[1][i]);
    MyIniFile->WriteString("PortE","Port" +IntToStr(i),GExchange->Cells[1][i]);
    MyIniFile->WriteString("PortE","Val"  +IntToStr(i),GExchange->Cells[2][i]);
    MyIniFile->WriteBool  ("PortE","Write"+IntToStr(i),Boolean(StrToInt(GExchange->Cells[3][i])));
 }
 delete MyIniFile;
 Close();        
}

ULONG CharToNumber(char ch)
  {
    int n,i;
    char hexh[17] = "0123456789ABCDEF";
    n = 0;
    for (i=0;i<=15;i++){ if (UpperCase(ch)==hexh[i]) n=i; }
    return n;
  }

int HexToInt(AnsiString s)
{

  int i,r,k;
  char    ch;

  k=1; r=0;
  for (i=s.Length();i>0; i--){
    ch=s[i];
    r=r+CharToNumber(ch)*k; if (i>1) k*=16;
  }
  return r;
}


//---------------------------------------------------------------------------
void __fastcall TForm1::FormActivate(TObject *Sender)
{
 int i;
 if ((int)GetVersion()<0) Label3->Caption = "Detected: Windows 95";
 else              Label3->Caption = "Detected: Windows NT";
 ShowButtons();

 TIniFile* MyIniFile = new TIniFile("HW_test");

 GWrite->Cells[1][0]="PORT";
 GWrite->Cells[2][0]="VAL";
 GRead->Cells[1][0]="PORT";
 GRead->Cells[2][0]="VAL";

 for (i=1; i<=16; i++){
  GWrite->Cells[0][i]=IntToStr(i);
  GWrite->Cells[1][i]=MyIniFile->ReadString("PortW","Port"+IntToStr(i),"0000");
  GWrite->Cells[2][i]=MyIniFile->ReadString("Values","Val"+IntToStr(i),"00");
  GRead->Cells[0][i]=IntToStr(i);
  GRead->Cells[1][i]=MyIniFile->ReadString("PortR","Port"+IntToStr(i),"0000");
  GRead->Cells[2][i]="..";
  GExchange->Cells[0][i]=IntToStr(i);
  GExchange->Cells[1][0]="PORT";
  GExchange->Cells[2][0]="VAL";
  GExchange->Cells[3][0]="W";
  GExchange->Cells[1][i]=MyIniFile->ReadString("PortE","Port"+IntToStr(i),"");
  GExchange->Cells[2][i]=MyIniFile->ReadString("PortE","Val"+IntToStr(i),"");
  GExchange->Cells[3][i]=IntToStr(Byte(MyIniFile->ReadBool("PortE","Write"+IntToStr(i),FALSE)));
 }

 delete MyIniFile;

}
//---------------------------------------------------------------------------
void __fastcall TForm1::B_WriteClick(TObject *Sender)
{
   PortWSel=(Word)HexToInt(GWrite->Cells[1][GWrite->Row]);
   GWrite->Cells[1][GWrite->Row]=IntToHex(PortWSel,4);
   ValWSel=(UCHAR)HexToInt(GWrite->Cells[2][GWrite->Row]);
   GWrite->Cells[2][GWrite->Row]=IntToHex(ValWSel,2);
   NomWSel=(Word)GWrite->Row;
   if (PortWSel==0) {MessageBeep(0); return;}
   HwCtrl->Port[PortWSel]=(UCHAR) ValWSel;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::B_ReadClick(TObject *Sender)
{
   PortRSel=(Word)HexToInt(GRead->Cells[1][GRead->Row]);
   GRead->Cells[1][GRead->Row]=IntToHex(PortRSel,4);
   NomRSel=(Word)GRead->Row;
   if (PortRSel==0) { MessageBeep(0); return; }
   GRead->Cells[2][GRead->Row]=IntToHex((int)HwCtrl->Port[PortRSel],2);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::B_ReadAllClick(TObject *Sender)
{
 UCHAR cl[17];
 Word  ports[17],P,N,i;

 N=0;
 for (i=1; i<=16; i++) {
   P=(Word)HexToInt(GRead->Cells[1][i]);
   GRead->Cells[1][i]=IntToHex(P,4);
   if(P) {ports[++N]=P; cl[N]=(UCHAR) i;}
 }
 for (i=1; i<=N; i++)
   GRead->Cells[2][cl[i]]=IntToHex((int)HwCtrl->Port[ports[i]],2);

}
//---------------------------------------------------------------------------
void __fastcall TForm1::B_WriteAllClick(TObject *Sender)
{
  Word i,P,V;
  for (i=1; i<=16; i++) {
    P=(Word)HexToInt(GWrite->Cells[1][i]); GWrite->Cells[1][i]=IntToHex(P,4);
    if (P) {
      V=(Word)HexToInt(GWrite->Cells[2][i]); GWrite->Cells[2][i]=IntToHex(V,2);
      HwCtrl->Port[P]=V;
    }
   }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::B_ExchangeClick(TObject *Sender)
{
 TPortRecord RecRec[17];
 Byte   i;
 int   P,N;
 Byte   cl[17];
 
   N = 0;
   for (i=1;i<17; i++){
     P = HexToInt(GExchange->Cells[1][i]);
     GExchange->Cells[1][i] = IntToHex((int)P,4);
     if(P>0) {
       N++;
       RecRec[N-1].nPort = (Word)P;
       RecRec[N-1].Data = (Word)HexToInt(GExchange->Cells[2][i]);
       RecRec[N-1].fWrite = GExchange->Cells[3][i]=='1';
       cl[N] = i;
     };
   }
   HwCtrl->PortExchange(RecRec,(Word)N);
   for (i=1; i<=N; i++) GExchange->Cells[2][cl[i]] = IntToHex(RecRec[i-1].Data,2);

}
//---------------------------------------------------------------------------
